import {
  Bbs as OldBbs,
  Bodypart as OldBodypart,
  Constant as OldConstant,
  Default_cost as OldDefault_cost,
  Department as OldDepartment,
  Device as OldDevice,
  Doctor_class as OldDoctor_class,
  Doctors as OldDoctors,
  Dr_cla_permission as OldDr_cla_permission,
  Every_studies as OldEvery_studies,
  Exam_class as OldExam_class,
  Exam_project as OldExam_project,
  Exam_subclass as OldExam_subclass,
  Exams as OldExams,
  Images as OldImages,
  Institution as OldInstitution,
  Manager as OldManager,
  Menu as OldMenu,
  Messages as OldMessages,
  Open_application as OldOpen_application,
  Operating as OldOperating,
  Oss_callbacks as OldOss_callbacks,
  Patient_infos as OldPatient_infos,
  Remote_application as OldRemote_application,
  Remote_contact as OldRemote_contact,
  Remote_cost as OldRemote_cost,
  Remote_order as OldRemote_order,
  Remote_water as OldRemote_water,
  Remote_water_log as OldRemote_water_log,
  Report as OldReport,
  Report_record as OldReport_record,
  Send_message as OldSend_message,
  Series as OldSeries,
  Studies as OldStudies,
  Sys_logs as OldSys_logs,
  Sys_menus as OldSys_menus,
  Templates as OldTemplates,
  User as OldUser,
  User_bind as OldUser_bind,
  Version as OldVersion,
  Wechat_bind as OldWechat_bind,
  Wechat_pay_log as OldWechat_pay_log,
  Wechat_refund_log as OldWechat_refund_log
} from '../../old_dao'


import {
  Bbs as TestBbs,
  Bodypart as TestBodypart,
  Constant as TestConstant,
  Default_cost as TestDefault_cost,
  Department as TestDepartment,
  Device as TestDevice,
  Doctor_class as TestDoctor_class,
  Doctors as TestDoctors,
  Dr_cla_permission as TestDr_cla_permission,
  Every_studies as TestEvery_studies,
  Exam_class as TestExam_class,
  Exam_project as TestExam_project,
  Exam_subclass as TestExam_subclass,
  Exams as TestExams,
  Images as TestImages,
  Institution as TestInstitution,
  Manager as TestManager,
  Menu as TestMenu,
  Messages as TestMessages,
  Open_application as TestOpen_application,
  Operating as TestOperating,
  Oss_callbacks as TestOss_callbacks,
  Patient_infos as TestPatient_infos,
  Remote_application as TestRemote_application,
  Remote_contact as TestRemote_contact,
  Remote_cost as TestRemote_cost,
  Remote_order as TestRemote_order,
  Remote_water as TestRemote_water,
  Remote_water_log as TestRemote_water_log,
  Report as TestReport,
  Report_record as TestReport_record,
  Send_message as TestSend_message,
  Series as TestSeries,
  Studies as TestStudies,
  Sys_logs as TestSys_logs,
  Sys_menus as TestSys_menus,
  Templates as TestTemplates,
  User as TestUser,
  User_bind as TestUser_bind,
  Version as TestVersion,
  Wechat_bind as TestWechat_bind,
  Wechat_pay_log as TestWechat_pay_log,
  Wechat_refund_log as TestWechat_refund_log,
  Register as TestRegister
} from '../../new_dao';
// exam
// register 
// messages is_remote exam_id
// remote_application
// report

// 新增 register
// Exams
// Images
// await copy(OldMessages, TestMessages, 'id'); // doctor_id 相等是2
// Patient_infos
// Remote_application
// Report as TestReport,
// Series as TestSeries,
// Studies as TestStudies,

import Sequelize from 'sequelize'
const fs = require('fs');
const path = require('path');

export async function message(ctx) {
  // is_remote exam_id              doctor_id = req_doctor_id 相等是2
  const messages = await TestMessages.findAll();
  for (let i = 0; i < messages.length; i++) {
    const message = messages[i];
    const application_id = message.application_id;
    const application = await TestRemote_application.findOne({ where: { id: application_id } });
    if (application) {
      message.exam_id = application.exam_id;
      message.is_remote = application.req_doctor_id === message.doctor_id ? '2' : '1';
      await message.save();
    }
  }
  console.log('同步完成')
  ctx.body = true;
}



export async function report(ctx) {
  const doctors = await TestDoctors.findAll();
  const doctorMap = {}
  for (let i = 0; i < doctors.length; i++) {
    const doctor = doctors[i];
    doctorMap[doctor.id] = doctor.realname;
  }
  let res = await limitCallBack(TestReport, 'report', reportCallback, { doctorMap });
  ctx.body = res;
  // report_doctor_name review_doctor_name confirm_doctor_name
}

export async function reportCallback(report, { doctorMap }) {
  report.report_doctor_name = doctorMap[report.report_doctor_id];
  report.review_doctor_name = doctorMap[report.review_doctor_id];
  report.confirm_doctor_name = doctorMap[report.confirm_doctor_id];
  await report.save();
  // report_doctor_name review_doctor_name confirm_doctor_name
}


export async function exam(ctx) {
  let res = await limitMultipleCallBack(TestExams, 'exams', examCallbck);
  console.log('同步完成')
  ctx.body = res;

  // name card_num studyid sex age birthday  exam_sub_class body_part device_name
  // report_result report_status:远程
  // del_datetime:del_time del_doctor_id:null
}
let count = 0;
export async function examCallbck(exam) {
  const patient = await TestPatient_infos.findOne({ where: { id: exam.patient_id } })
  const study = await TestStudies.findOne({ where: { id: exam.study_id } })
  const report = await TestReport.findOne({ where: { exam_id: exam.id, type: '1' } })
  if (patient) {
    let sex = patient && patient.sex;
    if (sex === '男' || sex === 'M') {
      sex = 'M';
    } else if (sex === '女' || sex === 'F') {
      sex = 'F';
    } else {
      sex = 'O';
    }
    exam.name = patient.name;
    exam.sex = sex;
    exam.age = patient.age;
    exam.birthday = patient.birthday;
  }

  if (report) {
    exam.report_result = report.report_result;
  }
  if (study) {
    study.exam_id = exam.id;
    exam.studyid = study.studyid;
    exam.studyuid = study.studyuid;
    exam.body_part = study.partExamined;
    await study.save();
  } else {
    exam.studyuid = 'nono';
  }
  await exam.save();
  // const register = await TestRegister.findOne({ where: { exam_id: exam.id } });
  // if (!register) {
  //   const oldExam = await OldExams.findOne({ where: { id: exam.id } });
  //   await TestRegister.create({
  //     id: uuid16(),
  //     exam_id: exam.id,
  //     register_datetime: oldExam.register_datetime,
  //     illness_desc: oldExam.illness_desc,
  //     phys_sign: oldExam.phys_sign,
  //     clin_symp: oldExam.lin_symp,
  //     anamnesis: oldExam.anamnesis,
  //     family_ill: oldExam.film_type,
  //     clin_diag: oldExam.clin_diag,
  //     ext: oldExam.ext
  //   })
  // }
  console.log(count++);
  // name card_num studyid sex age birthday  exam_sub_class body_part device_name
  // report_result report_status:远程
  // del_datetime:del_time del_doctor_id:null
}

export let uuid16 = () => {
  function S4() {
    return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
  }
  return ('1' + new Date().getTime().toString(16) + S4());
}

export async function register(ctx) {
  // id: { type: Sequelize.STRING(255), allowNull: false, primaryKey: true, comment: ''},
  // exam_id: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '检查key'},
  // exam_sub_class: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '检查子类'},
  // body_part: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '检查部位'},
  // null device_name: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '检查设备'},
  // null technician_id: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '检查技师ID'},
  // null technician_name: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '检查技师姓名'},
  // null technician_datetime: { type: Sequelize.DATE, allowNull: true, primaryKey: false, comment: '计划检查时间'},
  // null register_id: { type: Sequelize.STRING(50), allowNull: true, primaryKey: false, comment: '登记医师ID'},
  // null register_name: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '登记医师姓名'},
  // register_datetime: { type: Sequelize.DATE, allowNull: true, primaryKey: false, comment: '登记时间'},
  // illness_desc: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '患者主诉'},
  // phys_sign: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '体征'},
  // clin_symp: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '症状'},
  // anamnesis: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '疾病史'},
  // family_ill: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '家族病史'},
  // application_department: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '申请科室'},
  // clin_diag: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '初步诊断'},
  // ext: { type: Sequelize.TEXT, allowNull: true, primaryKey: false, comment: '备注'},
  // null clin_department: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '送诊科室'},
  // null clin_doctors_id: { type: Sequelize.STRING(50), allowNull: true, primaryKey: false, comment: '送诊医生ID'},
  // null clin_doctors_name: { type: Sequelize.STRING(255), allowNull: true, primaryKey: false, comment: '送诊医生姓名'},
  // null clin_datetime: { type: Sequelize.DATE, allowNull: true, primaryKey: false, comment: '送诊时间'},
}

// exam report
export async function remoteApplication(ctx) {
  const applications = await TestRemote_application.findAll();
  const hospitals = await TestInstitution.findAll();
  const hospitalMap = {}
  for (let i = 0; i < hospitals.length; i++) {
    const hospital = hospitals[i];
    if (hospital)
      hospitalMap[hospital.id] = hospital.name;
  }

  const doctors = await TestDoctors.findAll();
  const doctorMap = {}
  for (let i = 0; i < doctors.length; i++) {
    const doctor = doctors[i];
    doctorMap[doctor.id] = doctor.realname;
  }
  for (let i = 0; i < applications.length; i++) {
    const application = applications[i];
    const exam = await TestExams.findOne({ where: { id: application.exam_id } });
    if (exam) {
      application.name = exam.name;
      application.patient_num = exam.patient_num;
      application.accession_num = exam.accession_num;
      application.card_num = exam.card_num;
      application.sex = exam.sex;
      application.age = exam.age;
      application.birthday = exam.birthday;
      application.exam_sub_class = exam.exam_sub_class;
      application.body_part = exam.body_part;
      application.device_name = exam.device_name;
      application.exam_datetime = exam.exam_datetime;
      application.exam_class = exam.exam_class;
      application.exam_project = exam.exam_project;
      application.study_id = exam.study_id;
      application.studyid = exam.studyid;
      application.exam_sub_class = exam.exam_sub_class;
      application.body_part = exam.body_part;
      application.device_name = exam.device_name;
    }

    application.pay_status = '1';
    application.local_institution_name = hospitalMap[application.local_institution_id];
    application.remote_institution_name = hospitalMap[application.remote_institution_id];
    application.req_doctor_name = doctorMap[application.req_doctor_id];
    application.remote_doctor_name = doctorMap[application.req_doctor_id];
    const report = await TestReport.findOne({ where: { exam_id: application.exam_id, type: '2' } })
    if (report) {
      application.report_result = report.report_result;
      if (exam) {
        exam.report_result = application.report_status;
        await exam.save();
      }

    }
    await application.save();
  }
  ctx.body = true;
  // report_result
  // name sex age patient_num accession_num card_num birthday
  // exam_datetime exam_class exam_project body_part exam_sub_class study_id
  // local_institution_name req_doctor_name remote_institution_name
  // pay_status:1
}



export async function normalLimit(ctx) {
  const res = {};
  // await copyLimit(OldMessages, TestMessages, 'id');
  // await copyLimit(OldRemote_application, TestRemote_application, 'id');

  // await copyLimit(OldImages, TestImages, 'id');

  // res.patient_infos = await copyLimit(OldPatient_infos, TestPatient_infos, 'id', 'patient_infos');
  res.studies = await copyLimit(OldStudies, TestStudies, 'id', 'studies');
  // res.exams = await copyLimit(OldExams, TestExams, 'id', 'exams');
  // res.report = await copyLimit(OldReport, TestReport, 'id', 'report');
  // res.exams = await copyLimit(OldExams, TestExams, 'id', 'exams');

  // res.series = await copyLimit(OldSeries, TestSeries, 'id', 'series');
  // res.images = await copyLimit(OldImages, TestImages, 'id', 'images');

  const fileUri = path.join(__dirname, '../../logs', 'normalLimit.log');
  fs.writeFileSync(fileUri, JSON.stringify(res));
  ctx.body = res;
}

export async function normal(ctx) {
  const res = {};

  // Messages
  res.message = await copy(OldMessages, TestMessages, 'id', 'message');
  // Remote_application
  res.remote_application = await copy(OldRemote_application, TestRemote_application, 'id', 'remote_application');

  // Bbs
  res.bbs = await copy(OldBbs, TestBbs, 'id', 'bbs');
  // Bodypart
  res.bodypart = await copy(OldBodypart, TestBodypart, 'id', 'bodypart');
  // Constant
  res.constant = await copy(OldConstant, TestConstant, 'id', 'constant');
  // Default_cost
  res.default_cost = await copy(OldDefault_cost, TestDefault_cost, 'id', 'default_cost');
  // Department
  res.department = await copy(OldDepartment, TestDepartment, 'id', 'department');
  // Device
  res.device = await copy(OldDevice, TestDevice, 'id', 'device');
  // Doctor_class
  res.doctor_class = await copy(OldDoctor_class, TestDoctor_class, 'id', 'doctor_class');
  // Doctors
  res.doctors = await copy(OldDoctors, TestDoctors, 'id', 'doctors');
  // Dr_cla_permission
  res.dr_cla_permission = await copy(OldDr_cla_permission, TestDr_cla_permission, 'id', 'dr_cla_permission');
  // Every_studies
  res.every_studies = await copy(OldEvery_studies, TestEvery_studies, 'id', 'every_studies');
  // Exam_class
  res.exam_clas = await copy(OldExam_class, TestExam_class, 'id', 'exam_clas');
  // Exam_project
  res.exam_project = await copy(OldExam_project, TestExam_project, 'id', 'exam_project');
  // Exam_subclass
  res.exam_subclass = await copy(OldExam_subclass, TestExam_subclass, 'id', 'exam_subclass');
  // Institution
  res.institution = await copy(OldInstitution, TestInstitution, 'id', 'institution');
  // Menu
  res.menu = await copy(OldMenu, TestMenu, 'id', 'menu');
  // Messages
  res.messages = await copy(OldManager, TestManager, 'id', 'messages');
  // Open_application
  res.open_application = await copy(OldOpen_application, TestOpen_application, 'id', 'open_application');
  // Operating
  res.operating = await copy(OldOperating, TestOperating, 'id', 'operating');
  // Remote_contact
  res.remote_contact = await copy(OldRemote_contact, TestRemote_contact, 'id', 'remote_contact');
  // Remote_cost
  res.remote_cost = await copy(OldRemote_cost, TestRemote_cost, 'id', 'remote_cost');
  // Remote_order
  res.remote_order = await copy(OldRemote_order, TestRemote_order, 'id', 'remote_order');
  // Remote_water
  res.remote_water = await copy(OldRemote_water, TestRemote_water, 'id', 'remote_water');
  // Remote_water_log
  res.remote_water_log = await copy(OldRemote_water_log, TestRemote_water_log, 'id', 'remote_water_log');
  // Report_record
  res.report_record = await copy(OldReport_record, TestReport_record, 'id', 'report_record');
  // Send_message
  res.send_message = await copy(OldSend_message, TestSend_message, 'id', 'send_message');
  // Sys_logs
  res.sys_logs = await copy(OldSys_logs, TestSys_logs, 'id', 'sys_logs');
  // Sys_menus
  res.sys_menus = await copy(OldSys_menus, TestSys_menus, 'id', 'sys_menus');
  // Templates
  res.templates = await copy(OldTemplates, TestTemplates, 'id', 'templates');
  // User
  res.user = await copy(OldUser, TestUser, 'id', 'user');
  // User_bind
  res.user_bind = await copy(OldUser_bind, TestUser_bind, 'id', 'user_bind');
  // Version
  res.version = await copy(OldVersion, TestVersion, 'id', 'version');
  // Wechat_bind
  res.wechat_bind = await copy(OldWechat_bind, TestWechat_bind, 'id', 'wechat_bind');
  // Wechat_pay_log
  res.wechat_pay_log = await copy(OldWechat_pay_log, TestWechat_pay_log, 'id', 'wechat_pay_log');
  // Wechat_refund_log
  res.wechat_refund_log = await copy(OldWechat_refund_log, TestWechat_refund_log, 'id', 'wechat_refund_log');
  ctx.body = res;
}
async function copy(oldDb, newDb, key, tableName) {
  if (!newDb) {
    return { tableName, err: '没有新库' }
  }
  let olds = await oldDb.findAll();
  const errors = [];
  for (let i = 0; i < olds.length; i++) {
    const where = {};
    where[key] = olds[i][key];
    const old = await newDb.findOne({ where });

    if (!old) {
      try {
        newDb.create({...olds[i].dataValues });
      } catch (err) {
        errors.push(err.getMessage());
      }
    }
  }
  const oldCount = await oldDb.count();
  const newCount = await newDb.count();

  return {
    tableName,
    oldCount,
    newCount,
    dCount: newCount - oldCount,
    errors
  }
}
const Op = Sequelize.Op;
async function copyLimit(oldDb, newDb, key, tableName) {
  if (!newDb) {
    return { tableName, err: '没有新表' }
  }
  let createdAt = null;
  let id = null;
  const limit = 1;
  const order = [
    ['id', 'asc']
  ];
  const errors = [];
  let olds = await oldDb.findAll({
    limit,
    order,
    where: {
    //   id: {
    //     [Sequelize.Op.gt]: '116cc1a93d0ad836'
    //   }
      createdAt: {[Sequelize.Op.gte]: new Date('2019-11-28 12:00:00')}
    }
  });
  while (olds && olds.length) {
    for (let i = 0; i < olds.length; i++) {
      const where = {};
      where[key] = olds[i][key];
      console.log('old', where)
      const old = await newDb.findOne({ where });
      console.log('old', old)
      if (!old) {
        let obj = {...olds[i].dataValues };
        // if (tableName === 'images') {
        //   obj.image_id = obj.imageId;
        //   obj.sop_uid = obj.sopUid;
        //   obj.image_number = obj.imageNumber;
        //   obj.window_width = obj.windowWidth;
        //   obj.windo_center = obj.windoCenter;
        //   obj.pixe_spacing = obj.pixeSpacing;
        //   obj.image_position = obj.imagePosition;
        //   obj.image_orientation = obj.imageOrientation;
        //   obj.institution_id = obj.hospitalId;
        // }
        try {
          newDb.create(obj);
        } catch (err) {
          errors.push(err.getMessage());
        }
      }
      if (olds[i].id) {
        id = olds[i].id;
      }
    }
    olds = await oldDb.findAll({
      where: {
        id: {
          [Sequelize.Op.gt]: id,
          
        }
        ,createdAt: {[Sequelize.Op.gte]: new Date('2019-11-28 12:00:00')}
      },
      limit,
      order
    });
  }
  const oldCount = await oldDb.count();
  const newCount = await newDb.count();
  return {
    tableName,
    oldCount,
    newCount,
    dCount: newCount - oldCount,
    errors
  }
}



export async function limitCallBack(DbController, tableName, callback, param) {
  let id = null;
  const limit = 1000;
  const order = [
    ['id', 'asc']
  ];
  const errors = [];
  let olds = await DbController.findAll({
    limit,
    order
  });
  while (olds && olds.length) {
    for (let i = 0; i < olds.length; i++) {
      try {
        await callback(olds[i], param);
        id = olds[i].id;
      } catch (err) {
        console.log(err)
          // return
        errors.push(err.getMessage());
      }
    }
    olds = await DbController.findAll({
      where: {
        id: {
          [Sequelize.Op.gt]: id
        },
        createdAt: {[Sequelize.Op.gte]: new Date('2019-11-28 12:00:00')}
      },
      limit,
      order
    });
  }
  return {
    tableName,
    errors
  }
}

export async function limitMultipleCallBack(DbController, tableName, callback, param) {
  const dict = '0123456789abcdefghigklmnopqrstuvwxyz';

  let i = 0;
  let j = 0;
  while (i < dict.length) {
    j = 0;
    while (j < dict.length) {
      limitMultipleCallBackSingle(DbController, tableName, callback, param, dict[i] + dict[j], dict[i] + dict[j++] + 'ffffffffffffffff');
    }
    i++;
  }
  // limitMultipleCallBackSingle(DbController, tableName, callback, param, '116d6d', '116d' + 'ffffffffffffffff');
  // limitMultipleCallBackSingle(DbController, tableName, callback, param, '116f', '116f' + 'ffffffffffffffff');
}


export async function limitMultipleCallBackSingle(DbController, tableName, callback, params, start, end) {
  let id = start;
  const limit = 1000;
  const order = [
    ['id', 'asc']
  ];
  const errors = [];
  let olds = await DbController.findAll({
    limit,
    order,
    where: {
      id: {
        [Sequelize.Op.gt]: id,
        [Sequelize.Op.lt]: end
      },
      study_id: {
        [Op.ne]: null
      },
      studyuid: null,
      createdAt: {[Sequelize.Op.gte]: new Date('2019-11-28 12:00:00')}
    },
  });
  while (olds && olds.length) {
    for (let i = 0; i < olds.length; i++) {
      try {
        await callback(olds[i], params);
        id = olds[i].id;
      } catch (err) {
        console.log(err)
          // return
        errors.push(err.getMessage());
      }
    }
    olds = await DbController.findAll({
      where: {
        id: {
          [Sequelize.Op.gt]: id,
          [Sequelize.Op.lt]: end
        },
        study_id: {
          [Op.ne]: null
        },
        studyuid: null
      },
      limit,
      order
    });
  }
  return {
    tableName,
    errors
  }
}

let patientCounter  = 0;
let studyCounter  = 0;
let seriesCounter  = 0;
let imageCounter  = 0;

export async function importSinlgeHospital(ctx) {
  const hospitalId = ctx.request.body.hospitalId;
  // console.log('hospitalId', hospitalId)
  // return
  // const hospitalId = '24100002';
  const patients = await OldPatient_infos.findAll({where:{institution_id: hospitalId, 
    createdAt: {[Sequelize.Op.gte]: new Date('2020-01-14 12:00:00')}}})
  for(let i = 0; i < patients.length; i++) {
    await synchPatient(patients[i]);
  }
  ctx.body = {hospitalId, length: patients.length,patientCounter, studyCounter, seriesCounter, imageCounter}
  console.log(patients.length)
  console.log(patientCounter, studyCounter, seriesCounter, imageCounter)
  // const limit = 1000;
  // const order = [
  //   ['id', 'asc']
  // ];
  // let where = {
  // }
  // let patients = await OldPatient_infos.findAll({limit, order})
  
  // while(true) {
  //   let i = 0;
  //   while(i < patients.length) {
  //     await synchPatients(patients[i++]);
  //   }
  //   if(patients.length > 0) {
  //     patients = await OldPatient_infos.findAll({limit, order, where: {
  //       [Sequelize.Op.gt]: patients[patients.length - 1].id
  //     }})
  //   } else {
      console.log('同步完成');
      console.log('hospitalId', hospitalId)
  //     return;
  //   }
  // }
  
}

async function synchPatient(patient) {
  patientCounter++
  let old = await TestPatient_infos.findOne({where:{
    id: patient.id
  }});
  console.log('old', old)
  if(!old) {
    await TestPatient_infos.create({...patient.dataValues})
  }
  await synchStudies(patient.id);
// dataValues
}


async function synchStudies(patient_id) {
  const studies = await OldStudies.findAll({where: {patient_id}})
  for(let i = 0; i < studies.length; i++) {
    await synchStudy(studies[i]);
  }
}

async function synchStudy(study) {
  let old = await TestStudies.findOne({where:{id: study.id}});
  studyCounter++
  if(!old) {
    await TestStudies.create({...study.dataValues})
  }
  await synchSeries(study.id);
}

async function synchSeries(study_id) {
  const series = await OldSeries.findAll({where: {study_id}})
  for(let i = 0; i < series.length; i++) {
    await synchSerie(series[i]);
  }
}

async function synchSerie(serie) {
  seriesCounter++
  let old = await TestSeries.findOne({where:{id: serie.id}});
  if(!old) {
    await TestSeries.create({...serie.dataValues})
  }
  await synchImages(serie.id);
}

async function synchImages(series_id) {
  const images = await OldImages.findAll({where: {series_id}})
  for(let i = 0; i < images.length; i++) {
    await synchImage(images[i]);
  }
}

async function synchImage(image) {
  imageCounter++;
  let old = await TestImages.findOne({where:{id: image.id}});
 
  if(!old) {
    // console.log(image)
    // throw new Error('xxx')
    let i = {...image.dataValues}
    i.imageId = image.image_id;
    i.sopUid = image.sop_uid;
    i.imageNumber = image.image_number;
    i.windowWidth = image.window_width;
    i.windoCenter = image.windo_center;
    i.pixeSpacing = image.pixe_spacing;
    i.imagePosition = image.image_position;
    i.imageOrientation = image.image_orientation;
    i.hospitalId = image.institution_id;
    await TestImages.create(i)
  }
}

// 2.0      
// bbs  表          （对话表）
//   initiator（发起人）    关联  doctor  表id
//   remote_application_id        申请单id    关联  remote_application表id
// doctor_class表      （医生类别表）
// doctor_id  医生id
// department_id  科室id      关联department
// doctors表    （医生表）
// department_id  科室id
// exams表    （检查表）
// patient_id  患者id
// study_id
// messages表    （消息表）
// doctor_id  所属医生id
// application_id  申请单id
// remote_application  （申请单表）
// remote_doctor_id  申请的目标医生
// req_doctor_id  申请医生
// exam_id    检查表id
// report表    （报告表）
// exam_id  检查表id	
// report_doctor_id  报告医生id
// review_doctor_id  审核医生id
// confirm_doctor_id    确认医生id
// remote_application_id    申请单id
// report_record  （报告记录表）
// report_id    报告表id	
// -----------------------------------------------------------------------------------------------------------------------------------------
// 3.0
// 新增
// register表
// exam_id  检查表id
// technician_id    检查技师ID
// register_id	登记医师ID
// clin_doctors_id	送诊医生ID

// remote_application表
// 附加  local_institution_name  申请医院
// 附加  req_doctor_name    邀请方医生
// 附加    remote_institution_name  受邀方医院
// 附加  remote_doctor_name受邀方医生

// report  表
// 附加  report_doctor_name  报告医生姓名
// 附加  review_doctor_name  审核医生姓名
// 附加  confirm_doctor_id  确认医生姓名

// remote_application
//     accession_num
//     exam_project
//     exam_sub_class
//     body_part
//     birthday
//     card_num  
//     study_id
// doctors  表  新加字段
// messages 表 新加字段
